<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmEnderecoService;
use Zeedhi\Framework\DTO\Response;

class CrmEnderecoController
{

    protected $CrmEnderecoService;

    use TResponse;

    public function __construct(CrmEnderecoService $CrmEnderecoService)
    {
        $this->CrmEnderecoService = $CrmEnderecoService;
    }

    public function getPais(Request $request)
    {
        try {
            $data = $this->CrmEnderecoService->getPaisService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getEstadoFilter(Request $request)
    {
        try {
            $data = $this->CrmEnderecoService->getEstadoFilterService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getMunicipioFilter(Request $request)
    {
        try {
            $data = $this->CrmEnderecoService->getMunicipioFilterService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getBairroFilter(Request $request)
    {
        try {
            $data = $this->CrmEnderecoService->getBairroFilterService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getEstado(Request $request)
    {
        try {
            $data = $this->CrmEnderecoService->getEstadoService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getMunicipio(Request $request)
    {
        try {
            $data = $this->CrmEnderecoService->getMunicipioService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getBairro(Request $request)
    {
        try {
            $data = $this->CrmEnderecoService->getBairroService($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
