<?php

namespace CRM\Factory;

use CRM\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class CrmEnderecoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getPaisFactory()
    {

        $sql = "SELECT PAIS.CDPAIS, PAIS.NMPAIS FROM PAIS ORDER BY CASE WHEN UPPER(NMPAIS) = 'BRASIL' THEN 0 ELSE 1 END, NMPAIS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEstadoFilterFactory($params)
    {
        $sql = "SELECT NMESTADO, SGESTADO, CDPAIS
                FROM ESTADO
                WHERE CDPAIS = ($params)
                ORDER BY NMESTADO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getMunicipioFilterFactory($params)
    {
        $sql = "SELECT *
                FROM MUNICIPIO
                WHERE SGESTADO = '$params'
                ORDER BY NMMUNICIPIO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getBairroFilterFactory($params)
    {
        $sql = "SELECT *
                FROM BAIRRO
                WHERE SGESTADO = '$params'
                ORDER BY NMBAIRRO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEstadoFactory()
    {
        $sql = "SELECT NMESTADO, SGESTADO, CDPAIS
                FROM ESTADO
                ORDER BY NMESTADO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getMunicipioFactory()
    {
        $sql = "SELECT *
                FROM MUNICIPIO
                ORDER BY NMMUNICIPIO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getBairroFactory()
    {
        $sql = "SELECT *
                FROM BAIRRO
                ORDER BY NMBAIRRO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
