<?php

namespace CRM\Service;

use CRM\Factory\CrmEnderecoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmEnderecoService
{

    protected $CrmEnderecoFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, CrmEnderecoFactory $CrmEnderecoFactory)
    {
        $this->CrmEnderecoFactory = $CrmEnderecoFactory;
        $this->environment           = $environment;
        $this->newCode               = $newCode;
        $this->connection            = $entityManager->getConnection();
    }

    public function getPaisService()
    {
        return $this->CrmEnderecoFactory->getPaisFactory();
    }


    public function getEstadoFilterService($params)
    {
        $cdPaises = array("CDPAIS" => isset($params['CDPAIS']) ? $params['CDPAIS'] : null,);
        $data = implode(',', $cdPaises);
        return $this->CrmEnderecoFactory->getEstadoFilterFactory($data);
    }

    public function getMunicipioFilterService($params)
    {
        $sgestado = array("SGESTADO" => isset($params['SGESTADO']) ? $params['SGESTADO'] : null,);
        $data = implode(',', $sgestado);
        return $this->CrmEnderecoFactory->getMunicipioFilterFactory($data);
    }

    public function getBairroFilterService($params)
    {
        $sgestado = array("SGESTADO" => isset($params['SGESTADO']) ? $params['SGESTADO'] : null,);
        $data = implode(',', $sgestado);
        return $this->CrmEnderecoFactory->getBairroFilterFactory($data);
    }

        public function getEstadoService()
    {
        return $this->CrmEnderecoFactory->getEstadoFactory();
    }

    public function getMunicipioService()
    {
        return $this->CrmEnderecoFactory->getMunicipioFactory();
    }

    public function getBairroService()
    {
        return $this->CrmEnderecoFactory->getBairroFactory();
    }
}
